*****************************************************.
*****   Rechenbeispiele ordinale Modelle  ******.
*****   Modelle mit 3 Variablen                ******.
*****************************************************.
*****   Datenquelle: Clogg, 1982, Tabelle 1. 
*****************************************************.
data list / Sx 1-2, Hap 3-4,  Yr 5-6, hk 7-10.
begin data
 1 1 1  40
 1 1 2  21
 1 1 3  14
 1 1 4   3
 1 2 1 131
 1 2 2 116
 1 2 3 112
 1 2 4  27
 1 3 1  82
 1 3 2  61
 1 3 3  55
 1 3 4  27
 2 1 1  62
 2 1 2  26
 2 1 3  12
 2 1 4   3
 2 2 1 155
 2 2 2 156
 2 2 3  95
 2 2 4  15
 2 3 1  87
 2 3 2 127
 2 3 3  76
 2 3 4  15
end data.
weight by hk.
var lab Sx 'Geschlecht' / Hap 'Lebensfreude' /Yr 'Schuljahre' / hk 'Hufigkeit'.
val lab Sx 1 'm' 2 'w'
  / Hap 1 'not so happy' 2 'pretty happy' 3 'very happy'
  / Yr 1 '<12' 2 '12' 3 '13-16' 4'>16'.
*******************************************************************************.
**********           Einfache, dreidimensionale Kreuztabelle        ******.
*******************************************************************************.
CROSS tab = Hap by Yr by Sx.
*******************************************************************************.
***  Modell Null aus Tabelle 5 (df = 12, Chisq = 48,70)     *** . 
*******************************************************************************.
recode Sx (1=1)(2=-1) into Sex.
recode Hap (1=1)(2=0)(3=-1) into Hp_1.
recode Hap (1=0)(2=1)(3=-1) into Hp_2.
recode Yr (1=1)(2,3=0)(4=-1) into Yr_1.
recode Yr (1,3=0)(2=1)(4=-1) into Yr_2.
recode Yr (1,2=0)(3=1)(4=-1) into Yr_3.
compute SH_1 = Sex * Hp_1.
compute SH_2 = Sex * Hp_2.
compute SY_1 = Sex * Yr_1.
compute SY_2 = Sex * Yr_2.
compute SY_3 = Sex * Yr_3.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3 /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3 .
*******************************************************************************.
***  Modell 2a aus Tabelle 5 (df = 11, Chisq = 23,68)     ***   . 
*******************************************************************************.
recode Sx (1=1)(2=-1) into Sex.
recode Hap (1=1)(2=0)(3=-1) into Hp_1.
recode Hap (1=0)(2=1)(3=-1) into Hp_2.
recode Yr (1=1)(2,3=0)(4=-1) into Yr_1.
recode Yr (1,3=0)(2=1)(4=-1) into Yr_2.
recode Yr (1,2=0)(3=1)(4=-1) into Yr_3.
compute SH_1 = Sex * Hp_1.
compute SH_2 = Sex * Hp_2.
compute SY_1 = Sex * Yr_1.
compute SY_2 = Sex * Yr_2.
compute SY_3 = Sex * Yr_3.
compute HY = hap * Yr.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY.
*******************************************************************************.
***  Modell 2b aus Tabelle 5 (df = 10, Chisq = 20,92)     ***  . 
*******************************************************************************.
Compute SHY = Sex * HY.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY, SHY /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY, SHY.
*******************************************************************************.
***  Modell 3a aus Tabelle 5 (df = 10, Chisq = 15,33)     ***  . 
*******************************************************************************.
recode Sx (1=1)(2=-1) into Sex.
recode Hap (1=1)(2=0)(3=-1) into Hp_1.
recode Hap (1=0)(2=1)(3=-1) into Hp_2.
recode Yr (1=-3)(2=-1)(3=1)(4=3) into Yr_1.
recode Yr (1=1)(2=-1)(3=-1)(4=1) into Yr_2.
recode Yr (1=-1)(2=3)(3=-3)(4=1) into Yr_3.
compute SH_1 = Sex * Hp_1.
compute SH_2 = Sex * Hp_2.
compute SY_1 = Sex * Yr_1.
compute SY_2 = Sex * Yr_2.
compute SY_3 = Sex * Yr_3.
compute HY_1 = Yr_1 * Hp_1.
compute HY_2 = Yr_1 * Hp_2.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2 /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2  .
*******************************************************************************.
***  Modell 3b aus Tabelle 5 (df = 9, Chisq = 13,36)     ***  . 
*******************************************************************************.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, SHY /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, hy_1,Hy_2,SHY.
*******************************************************************************.
*****      Modell 3c aus Tabelle 5 (df = 8, Chisq = 13,4)       ***********. 
*******************************************************************************.
Compute SHY_1 = Sx * HY_1.
Compute SHY_2 = Sx * HY_2.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, SHY_1, SHY_2 /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, SHY_1, SHY_2.
*******************************************************************************.
***  Modell 4a aus Tabelle 5 (df = 9, Chisq = 19,96)    ***   . 
*******************************************************************************.
recode Hap (1=-1)(2=0)(3=1) into Hp_1.
recode Hap (1=1)(2=-2)(3=1) into Hp_2.
recode Yr (1=1)(2,3=0)(4=-1) into Yr_1.
recode Yr (1,3=0)(2=1)(4=-1) into Yr_2.
recode Yr (1,2=0)(3=1)(4=-1) into Yr_3.
compute SH_1 = Sex * Hp_1.
compute SH_2 = Sex * Hp_2.
compute SY_1 = Sex * Yr_1.
compute SY_2 = Sex * Yr_2.
compute SY_3 = Sex * Yr_3.
compute HY_1 = Yr_1 * Hp_1.
compute HY_2 = Yr_2 * Hp_1.
compute HY_3 = Yr_3 * Hp_1.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, HY_3 /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, HY_3  .
*******************************************************************************.
***  Modell 4b aus Tabelle 5 (df = 8, Chisq = 17,31)    ***   . 
*******************************************************************************.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, HY_3, SHY /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, HY_3, SHY  .
*******************************************************************************.
******       Modell 4c aus Tabelle 5 (df = 6, Chisq = 11,52)    ********** . 
*******************************************************************************.
Compute SHY_1 = Sx * HY_1.
Compute SHY_2 = Sx * HY_2.
Compute SHY_3 = Sx * HY_3.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, HY_3, SHY_1, SHY_2, SHY_3 /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_1, HY_2, HY_3, SHY_1, SHY_2, SHY_3  .
*******************************************************************************.
***  Modell 5a aus Tabelle 5 (df = 8, Chisq = 12,72)    ***   . 
*******************************************************************************.
recode Sx (1=1)(2=-1) into Sex.
recode Yr (1=-3)(2=-1)(3=1)(4=3) into Yr_1.
recode Yr (1=1)(2=-1)(3=-1)(4=1) into Yr_2.
recode Yr (1=-1)(2=3)(3=-3)(4=1) into Yr_3.
recode Hap (1=-1)(2=0)(3=1) into Hp_1.
recode Hap (1=1)(2=-2)(3=1) into Hp_2.
compute SH_1 = Sex * Hp_1.
compute SH_2 = Sex * Hp_2.
compute SY_1 = Sex * Yr_1.
compute SY_2 = Sex * Yr_2.
compute SY_3 = Sex * Yr_3.
compute HY_11 = Yr_1 * Hp_1.
compute HY_21 = Yr_2 * Hp_1.
compute HY_31 = Yr_3 * Hp_1.
compute HY_12 = Yr_1 * Hp_2.
compute HY_22 = Yr_2 * Hp_2.
compute HY_32 = Yr_3 * Hp_2.
genlog Sx Hap Yr  with  Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3,  HY_11, HY_21, HY_31,HY_12, HY_22, HY_32 /model = multinomial / print = des, estim, freq
  /plot = none /crit = delta(0) / des = Sex, Hp_1, Hp_2, Yr_1, Yr_2, Yr_3, SH_1, SH_2, SY_1, SY_2, SY_3, HY_11, HY_21, HY_31,HY_12.

